<template>
  <div class="clickable">
      <div v-show="props.row[auto] == props.row[manual] || props.row[auto2] == props.row[manual] ">
            <q-chip color="white" text-color="red" dense v-show="props.row[auto].length > 0">{{ props.row[auto] }}</q-chip>
            <q-chip color="white" text-color="red" dense v-show="props.row[auto].length <= 0">{{ props.row[auto2] }}</q-chip>
            <q-popup-edit v-model="props.row[manual]" buttons label-set="Save" @save="saveData()" :disable="disable">
              <q-input v-model="props.row[manual]" dense persistent autofocus counter />
            </q-popup-edit>
            <q-tooltip :delay="300" content-class="bg-grey-1 text-primary">Automatic value</q-tooltip>
      </div>
      <div v-show="props.row[auto] != props.row[manual] && props.row[auto2] != props.row[manual] ">
          <q-chip color="white" text-color="green" dense>{{ props.row[manual] }}</q-chip>
          <q-popup-edit v-model="props.row[manual]" buttons label-set="Save" @save="saveData()" :disable="disable">
            <q-input v-model="props.row[manual]" dense persistent autofocus counter />
          </q-popup-edit>
          <q-menu touch-position context-menu v-show="!disable">
            <q-list dense style="min-width: 100px">
                <q-item clickable v-close-popup>
                <q-item-section @click="revoke()" >Revoke manual changes</q-item-section>
                </q-item>
            </q-list>
          </q-menu>
          <q-tooltip :delay="300" content-class="bg-grey-1 text-primary">Manual value, Right-click on it to show options.</q-tooltip>
      </div>
  </div>
</template>

<script>
module.exports = {
  data: function () {
    return {
    }
  },
  props: ['props', 'manual', 'auto', 'parentSaveData', 'disable', 'auto2'],
  methods: {
    saveData(){ this.parentSaveData(); }, // access parent method as prop
    revoke(){
      let auto = this.props.row[this.auto]
      let auto2 = this.props.row[this.auto2]
      let manual = this.props.row[this.manual]
      if(auto2 == "" || auto2 == null){
        this.props.row[this.manual] = this.props.row[this.auto];
      } else if(auto == ""){
        this.props.row[this.manual] = this.props.row[this.auto2]
      } else {
        this.props.row[this.manual] = this.props.row[this.auto];
      }
      this.saveData();
    }
  }
}
</script>

<style scoped>
.clickable {
  cursor:pointer;
}
</style>